/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package at.fhooe.mc.magicwand.client.gui;

import at.fhooe.mc.magicwand.client.controller.Controller;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

/**
 *
 * @author Maria
 * @brief this class contains the gui implementation and uses J2ME polish to display the forms
 */
public class GuiMIDlet extends MIDlet implements ItemStateListener, CommandListener {

    private Controller m_control;
    private Display m_display;
    private boolean m_midletPaused = false;
    private Form m_splashScreen;
    private Form m_mainScreen;
    private Form m_optionsScreen;
    private Form m_filterScreen;
    private Form m_viewScreen;
    private Form m_loadScreen;
    private Form m_resultScreen;
    private Command m_cmdExit;
    private Command m_cmdOk;
    private Command m_cmdBack;
    private Command m_cmdOptions;
    private Command m_cmdFilter;
    private Command m_cmdView;
    private Command m_cmdAbort;
    private ChoiceGroup m_itmDistance;
    private ChoiceGroup m_itmFilter;
    private ChoiceGroup m_itmView;
    private TextField m_txfDistance;
    private String[] m_options;

    /**
     * @fn public gui()
     * @brief creates display
     */
    public GuiMIDlet() {
        m_display = Display.getDisplay(this);
        //m_conn = new ClientServerConnection(4444);
        m_options = new String[2];
        m_control = new Controller();
    }

    /**
     * @fn public void destroyApp(boolean unconditional)
     * @param unconditional
     * @brief destroys the application, closes the connection
     */
    public void destroyApp(boolean unconditional) {
        //m_conn.closeConnection();
    }

    /**
     * @fn public void startApp()
     * @brief starts the application and server connection
     */
    public void startApp() {
        if (m_midletPaused) {
            resumeMIDlet();
        } else {
            startMIDlet();
        }
        m_midletPaused = false;
        m_control = new Controller();

    }

    /**
     * @fn public void pauseApp()
     * @brief pauses the application
     */
    public void pauseApp() {
        m_midletPaused = true;
    }

    /**
     * @fn private Form buildSplashScreen()
     * @return splashScreen
     * @brief creates the splashScreen
     */
    private Form buildSplashScreen() {

        Form f = new Form(" ");

        f.append("Paul Klingelhuber");

        f.append("    Manuel Lachberger");

        f.append("        Maria Neumayer");

        f.append("             Manuela Vogler");
        m_splashScreen = f;
        return f;
    }

    /**
     * @fn private Form buildMainScreen()
     * @return mainScreen
     * @brief creates the mainScreen, where the user can start a search or call the optionsScren
     */
    private Form buildMainScreen() {
        //#style Form
        Form f = new Form(" ");

        //#style FormItem
        f.append("Handy in gew�nschte Richtung halten und Men� - Start w�hlen");

        m_cmdExit = new Command("Ende", Command.EXIT, 0);
        m_cmdOk = new Command("Start", Command.OK, 0);
        m_cmdOptions = new Command("Optionen", Command.ITEM, 0);

        f.addCommand(m_cmdOk);
        f.addCommand(m_cmdOptions);
        f.addCommand(m_cmdExit);

        f.setCommandListener(this);
        m_mainScreen = f;
        return f;
    }

    /**
     * @fn private Form buildOptionsScreen()
     * @return optionsScreen
     * @brief creates the OptionsScreen where the user can change the settings for the search
     */
    private Form buildOptionsScreen() {
        //#style Form
        Form f = new Form("Suchgebiet");

        //#style FormItem
        f.append("max. Entfernung (m):");
        m_txfDistance = new TextField("", "", 30, TextField.DECIMAL);

        m_itmDistance = new ChoiceGroup("", ChoiceGroup.EXCLUSIVE);

        //#style choiceItem
        m_itmDistance.append("pr�zise", null);

        //#style choiceItem
        m_itmDistance.append("gro�z�gig", null);

        //#style TextField
        f.append(m_txfDistance);

        f.append(m_itmDistance);

        m_cmdBack = new Command("Zur�ck", Command.BACK, 0);
        m_cmdOk = new Command("Anwenden", Command.OK, 0);

        f.addCommand(m_cmdOk);
        f.addCommand(m_cmdBack);

        f.setCommandListener(this);
        f.setItemStateListener(this);
        m_optionsScreen = f;
        return f;
    }

    /**
     * @fn  private Form buildLoadScreen()
     * @return loadScreen
     * @brief creates the loadScreen where the data is sent and received
     */
    private Form buildLoadScreen() {
        //#style Form
        Form f = new Form(" ");

        //#style FormItem
        f.append("Daten werden ermittelt...");

        m_cmdAbort = new Command("Abbrechen", Command.CANCEL, 0);

        f.addCommand(m_cmdAbort);

        f.setCommandListener(this);
        m_loadScreen = f;
        return f;
    }

    /**
     * @fn private Form buildResultScreen()
     * @return resultScreen
     * @brief creates the resultScreen where the result-data is shown, the user can make another search, call the filterScreen or the viewScreen
     */
    private Form buildResultScreen() {
        //#style Form
        Form f = new Form("Ergebnisse");

        m_cmdExit = new Command("Ende", Command.EXIT, 0);
        m_cmdOk = new Command("Neue Suche", Command.OK, 0);
        m_cmdFilter = new Command("Filter", Command.ITEM, 0);
        m_cmdView = new Command("Ansichten", Command.ITEM, 0);

        f.addCommand(m_cmdOk);
        f.addCommand(m_cmdFilter);
        f.addCommand(m_cmdView);
        f.addCommand(m_cmdExit);

        f.setCommandListener(this);
        m_resultScreen = f;
        return f;
    }

    /**
     * @fn private Form buildFilterScreen()
     * @return filterScreen
     * @brief creates the filterScreen where the user can filter the results by selecting different categorys
     */
    private Form buildFilterScreen() {
        //#style Form
        Form f = new Form("Filter");

        m_itmFilter = new ChoiceGroup("", ChoiceGroup.MULTIPLE);

        //#style choiceItem
        m_itmFilter.append("keine Kategorie", null);

        //#style choiceItem
        m_itmFilter.append("Sehensw�rdigkeiten", null);

        //#style choiceItem
        m_itmFilter.append("Tankstellen", null);

        //#style choiceItem
        f.append(m_itmFilter);

        m_cmdBack = new Command("Zur�ck", Command.BACK, 0);
        m_cmdOk = new Command("Anwenden", Command.OK, 0);

        f.addCommand(m_cmdOk);
        f.addCommand(m_cmdBack);

        f.setCommandListener(this);
        m_filterScreen = f;
        return f;
    }

    /**
     * @fn private Form buildViewScreen()
     * @return viewScreen
     * @brief creates the viewScreen where the user can change the view of the result
     */
    private Form buildViewScreen() {
        //#style Form
        Form f = new Form("Ansichten");

        m_itmView = new ChoiceGroup("", ChoiceGroup.EXCLUSIVE);

        //#style choiceItem
        m_itmView.append("Name", null);

        //#style choiceItem
        m_itmView.append("Name, Beschreibung", null);

        //#style choiceItem
        m_itmView.append("Name, Beschreibung, Link", null);


        f.append(m_itmView);

        m_cmdBack = new Command("Zur�ck", Command.BACK, 0);
        m_cmdOk = new Command("Anwenden", Command.OK, 0);

        f.addCommand(m_cmdOk);
        f.addCommand(m_cmdBack);

        f.setCommandListener(this);
        m_viewScreen = f;
        return f;
    }

    /**
     * @fn public void commandAction(Command cmd, Displayable displayable)
     * @param cmd triggered command
     * @param displayable current display
     * @brief handels the commandActions of the application
     */
    public void commandAction(Command _cmd, Displayable _displayable) {
        if (_cmd == m_cmdExit) {
            exitMIDlet();
        } else if (_cmd == m_cmdOk) {
            if (_displayable == m_splashScreen) {
                m_display.setCurrent(buildMainScreen());
            } else if (_displayable == m_mainScreen) {
                m_display.setCurrent(buildLoadScreen());
                //create new request:
                if (m_itmDistance != null && m_txfDistance != null) {
                    int selected = m_itmDistance.getSelectedIndex();
                    if (selected >= 0) {
                        String value = m_itmDistance.getString(selected);
                        m_control.makeRequest(m_txfDistance.getString(), value);
                    } else {
                        m_control.makeRequest(m_txfDistance.getString(), "");
                    }
                }
                else {
                    m_control.makeRequest(null,null);
                }
                //TODO
                //check after parsing of xml is done?
                if (m_control.isRequestSuccessful())
                     m_display.setCurrent(buildResultScreen());
                else
                    m_display.setCurrent(buildMainScreen());
                //boolean success = m_conn.sendAndReceive();
                /**boolean success = true;
                if (success) {
                    m_display.setCurrent(buildResultScreen());
                } else {
                    m_display.setCurrent(buildMainScreen());
                }*/
            } else if (_displayable == m_optionsScreen) {
                if (m_options[0] == null || m_options[1] == null) {
                    Alert a = new Alert("Fehler");
                    a.setString("Eingabe nicht komplett");
                    m_display.setCurrent(a, _displayable);
                } else {
                    m_control.setOptions(m_options);
                    m_display.setCurrent(buildMainScreen());
                }
            } else if (_displayable == m_filterScreen) {
                m_display.setCurrent(buildResultScreen());
            } else if (_displayable == m_viewScreen) {
                m_display.setCurrent(buildResultScreen());
            } else if (_displayable == m_resultScreen) {
                m_display.setCurrent(buildMainScreen());
            }
        } else if (_cmd == m_cmdBack) {
            if (_displayable == m_optionsScreen) {
                m_display.setCurrent(buildMainScreen());
            } else if (_displayable == m_filterScreen) {
                m_display.setCurrent(buildResultScreen());
            } else if (_displayable == m_viewScreen) {
                m_display.setCurrent(buildResultScreen());
            }
        } else if (_cmd == m_cmdAbort) {
            m_display.setCurrent(buildMainScreen());
        } else if (_cmd == m_cmdOptions) {
            m_display.setCurrent(buildOptionsScreen());
        } else if (_cmd == m_cmdFilter) {
            m_display.setCurrent(buildFilterScreen());
        } else if (_cmd == m_cmdView) {
            m_display.setCurrent(buildViewScreen());
        }
    }

    /**
     * @fn public void itemStateChanged(Item item)
     * @param item triggered item
     * @brief handels the itemStateChange of the application
     */
    public void itemStateChanged(Item _item) {
        if (_item == m_itmDistance) {
            if (m_itmDistance.getSelectedIndex() == 0) {
                m_options[1] = "true";
            } else if (m_itmDistance.getSelectedIndex() == 1) {
                m_options[1] = "false";
            }
        }

        if (_item == m_itmFilter) {
            boolean[] selected = new boolean[m_itmFilter.size()];
            m_itmFilter.getSelectedFlags(selected);
            if (selected[0]) {
            } else if (selected[1]) {
            } else if (selected[2]) {
            }
        }

        if (_item == m_itmView) {
            boolean[] selected = new boolean[m_itmView.size()];
            m_itmView.getSelectedFlags(selected);
            if (selected[0]) {
            } else if (selected[1]) {
            } else if (selected[2]) {
            }
        }

        if (_item == m_txfDistance) {
            m_options[0] = m_txfDistance.getString();
        }
    }

    /**
     * @fn public void resumeMIDlet()
     * @brief Performs an action assigned to the Mobile Device - MIDlet Resumed point.
     */
    public void resumeMIDlet() {
    }

    /**
     * @fn public Display getDisplay()
     * @return the display instance.
     * @brief Returns a display instance.
     */
    public Display getDisplay() {
        return Display.getDisplay(this);
    }

    /**
     * @fn public void exitMIDlet()
     * @brief Exits MIDlet.
     */
    public void exitMIDlet() {

        m_control.exitConnection();
        m_display.setCurrent(null);
        destroyApp(true);
        notifyDestroyed();
    }

    /**
     * @fn public void startMIDlet()
     * @brief Performs an action assigned to the Mobile Device - MIDlet Started point.
     */
    public void startMIDlet() {
        m_display.setCurrent(buildSplashScreen());
        try {
            Thread.sleep(5000);
        } catch (InterruptedException ex) {
            ex.printStackTrace();
        }
        m_display.setCurrent(buildMainScreen());


    }
}
