/*
 ========================================================================
 Name        : MagicWandServerContainerView.cpp
 Author      : Manuela Vogler
 Copyright   : 
 Description : 
 ========================================================================
 */
// [[[ begin generated region: do not modify [Generated System Includes]
#include <aknviewappui.h>
#include <eikmenub.h>
#include <avkon.hrh>
#include <barsread.h>
#include <stringloader.h>
#include <eiklabel.h>
#include <eikenv.h>
#include <akncontext.h>
#include <akntitle.h>
#include <eikbtgpc.h>
#include <MagicWandServer.rsg>
// ]]] end generated region [Generated System Includes]

// [[[ begin generated region: do not modify [Generated User Includes]

#include "MagicWandServer.hrh"
#include "MagicWandServerContainerView.h"
#include "MagicWandServerContainer.hrh"
#include "MagicWandServerContainer.h"
// ]]] end generated region [Generated User Includes]

// [[[ begin generated region: do not modify [Generated Constants]
// ]]] end generated region [Generated Constants]

/**
 * @brief First phase of Symbian two-phase construction. 
 */
CMagicWandServerContainerView::CMagicWandServerContainerView()
	{
	// [[[ begin generated region: do not modify [Generated Contents]
	iMagicWandServerContainer = NULL;
	// ]]] end generated region [Generated Contents]

	}

/** 
 * @brief Destructor. Removes the container from the control
 * stack and destroys it.
 */
CMagicWandServerContainerView::~CMagicWandServerContainerView()
	{
	// [[[ begin generated region: do not modify [Generated Contents]
	delete iMagicWandServerContainer;
	iMagicWandServerContainer = NULL;
	// ]]] end generated region [Generated Contents]

	}

/**
 * @brief Symbian two-phase constructor.
 * This creates an instance, then calls the second-phase constructor
 * without leaving the instance on the cleanup stack.
 * @return New instance of CMagicWandServerContainerView
 */
CMagicWandServerContainerView* CMagicWandServerContainerView::NewL()
	{
	CMagicWandServerContainerView* self =
			CMagicWandServerContainerView::NewLC();
	CleanupStack::Pop(self);
	return self;
	}

/**
 * @brief Symbian two-phase constructor.
 * This creates an instance, pushes it on the cleanup stack,
 * then calls the second-phase constructor.
 * @return New instance of CMagicWandServerContainerView
 */
CMagicWandServerContainerView* CMagicWandServerContainerView::NewLC()
	{
	CMagicWandServerContainerView* self =
			new (ELeave) CMagicWandServerContainerView();
	CleanupStack::PushL(self);
	self->ConstructL();
	return self;
	}

/**
 * @brief Second-phase constructor for view.  
 * Initializes contents from resource.
 */
void CMagicWandServerContainerView::ConstructL()
	{
	// [[[ begin generated region: do not modify [Generated Code]
	BaseConstructL( R_MAGIC_WAND_SERVER_CONTAINER_MAGIC_WAND_SERVER_CONTAINER_VIEW );
				
	// ]]] end generated region [Generated Code]

	// add your own initialization code here
	}

/**
 * @brief Returns the UID for this view.
 * @return The UID for this view
 */
TUid CMagicWandServerContainerView::Id() const
	{
	return TUid::Uid(EMagicWandServerContainerViewId);
	}

/**
 * @brief Handles a command for this view (override)
 * @param aCommand Command id to be handled
 */
void CMagicWandServerContainerView::HandleCommandL(TInt aCommand)
	{
	// [[[ begin generated region: do not modify [Generated Code]
	TBool commandHandled = EFalse;
	switch (aCommand)
			{ //forward the commands to the appui and let them be handled there
			case EMagicWandServerContainerViewStartMenuItemCommand:
				AppUi()->HandleCommandL(EMagicWandServerContainerViewStartMenuItemCommand);
				break;
			case EMagicWandServerContainerViewStopMenuItemCommand:
				AppUi()->HandleCommandL(EMagicWandServerContainerViewStopMenuItemCommand);
				break;
			default:
				break;
			}
		
	if ( !commandHandled ) 
		{
	
		if ( aCommand == EAknSoftkeyExit )
			{
			AppUi()->HandleCommandL( EEikCmdExit );
			}
	
		}
	// ]]] end generated region [Generated Code]

	}

/**
 *	@brief Handles user actions during activation of the view, 
 *	such as initializing the content.
 */
void CMagicWandServerContainerView::DoActivateL(
		const TVwsViewId& /*aPrevViewId*/, TUid /*aCustomMessageId*/,
		const TDesC8& /*aCustomMessage*/)
	{
	// [[[ begin generated region: do not modify [Generated Contents]
	SetupStatusPaneL();
	
				
				
	
	if ( iMagicWandServerContainer == NULL )
		{
		iMagicWandServerContainer = CreateContainerL();
		iMagicWandServerContainer->SetMopParent( this );
		AppUi()->AddToStackL( *this, iMagicWandServerContainer );
		} 
	// ]]] end generated region [Generated Contents]

	}

/**
 * @brief Deactivates the view. Destroys the container.
 */
void CMagicWandServerContainerView::DoDeactivate()
	{
	// [[[ begin generated region: do not modify [Generated Contents]
	CleanupStatusPane();
	
	if ( iMagicWandServerContainer != NULL )
		{
		AppUi()->RemoveFromViewStack( *this, iMagicWandServerContainer );
		delete iMagicWandServerContainer;
		iMagicWandServerContainer = NULL;
		}
	// ]]] end generated region [Generated Contents]

	}

/** 
 * @brief Handles status pane size change for this view (override).
 */
void CMagicWandServerContainerView::HandleStatusPaneSizeChange()
	{
	CAknView::HandleStatusPaneSizeChange();

	// this may fail, but we're not able to propagate exceptions here
	TVwsViewId view;
	AppUi()->GetActiveViewId(view);
	if (view.iViewUid == Id())
		{
		TInt result;
			TRAP( result, SetupStatusPaneL() );
		}

	// [[[ begin generated region: do not modify [Generated Code]
	// ]]] end generated region [Generated Code]

	}

// [[[ begin generated function: do not modify
/**
 * @brief Creates the status panel.
 */
void CMagicWandServerContainerView::SetupStatusPaneL()
	{
	// reset the context pane
	TUid contextPaneUid = TUid::Uid( EEikStatusPaneUidContext );
	CEikStatusPaneBase::TPaneCapabilities subPaneContext = 
		StatusPane()->PaneCapabilities( contextPaneUid );
	if ( subPaneContext.IsPresent() && subPaneContext.IsAppOwned() )
		{
		CAknContextPane* context = static_cast< CAknContextPane* > ( 
			StatusPane()->ControlL( contextPaneUid ) );
		context->SetPictureToDefaultL();
		}
	
	// setup the title pane
	TUid titlePaneUid = TUid::Uid( EEikStatusPaneUidTitle );
	CEikStatusPaneBase::TPaneCapabilities subPaneTitle = 
		StatusPane()->PaneCapabilities( titlePaneUid );
	if ( subPaneTitle.IsPresent() && subPaneTitle.IsAppOwned() )
		{
		CAknTitlePane* title = static_cast< CAknTitlePane* >( 
			StatusPane()->ControlL( titlePaneUid ) );
		TResourceReader reader;
		iEikonEnv->CreateResourceReaderLC( reader, R_MAGIC_WAND_SERVER_CONTAINER_TITLE_RESOURCE );
		title->SetFromResourceL( reader );
		CleanupStack::PopAndDestroy(); // reader internal state
		}
				
	}

// ]]] end generated function

// [[[ begin generated function: do not modify
/**
 * @brief Cleans up the status pane.
 */
void CMagicWandServerContainerView::CleanupStatusPane()
	{
	}

// ]]] end generated function

/**
 *	@brief Creates the top-level container for the view.  
 *	@return New initialized instance of CMagicWandServerContainer
 */
CMagicWandServerContainer* CMagicWandServerContainerView::CreateContainerL()
	{
	return CMagicWandServerContainer::NewL(ClientRect(), NULL, this);
	}

/**
 * @brief Dynamically adapts the menu pane. Just shows the menu items that are needed.
 * @param aResourceId ID of resource
 * @param aMenuPane Reference to the menu pane
 */
void CMagicWandServerContainerView::DynInitMenuPaneL(TInt aResourceId,
		CEikMenuPane* aMenuPane)
	{
	if (aResourceId == R_MAGIC_WAND_SERVER_CONTAINER_MENU_PANE1_MENU_PANE)
		{
		// Dim the item depending on the application state
		aMenuPane->SetItemDimmed(
				EMagicWandServerContainerViewStartMenuItemCommand,
				iMagicWandServerContainer->GetServerStarted());
		aMenuPane->SetItemDimmed(
				EMagicWandServerContainerViewStopMenuItemCommand,
				!iMagicWandServerContainer->GetServerStarted());
		}
	}
/**
 * @brief Returns a reference to the GUI container.
 * @return Pointer to the container
 */
CMagicWandServerContainer* CMagicWandServerContainerView::GetContainer()
	{
	return iMagicWandServerContainer;
	}
